function matlab_multigrain(input_gray,sigma_s,sigma_r,base,N,command_file)

sigma_s     = str2double(sigma_s);
sigma_r     = str2double(sigma_r);
N           = str2double(N);

cmdfile     = fopen(command_file,'r');
cmdline     = fread(cmdfile,'*char')';
fclose(cmdfile);

textformat  = '%s %d';
for n=1:N, textformat = [textformat ' %d']; end;
grainsizes  = textscan(cmdline,textformat);

weightfunspace = @(A)(exp( -A   /(2*sigma_s^2)));
% weightfunrange = @(u)(exp( -u.^2/(2*sigma_r^2)));
% weightfunrange = @(u)(double(abs(u)<=sigma_r));
weightfunrange = @(u)( u.*(abs(u)<=sigma_r) +sigma_r*(u>sigma_r) -sigma_r*(u<-sigma_r));

input          = double(imread(input_gray));
grain_prev     = input;
detail_layer   = zeros(size(input));

for n=1:N
    
    filename     = sprintf('grain%03d.png',n-1);
    grain_curr   = double(imread(filename));
    
    inter_grain  = grain_prev - grain_curr;
    grain_prev   = grain_curr;
    
    detail_layer = detail_layer + ...
                   weightfunrange(inter_grain).*...
                   weightfunspace(double(grainsizes{2+n}));
                               
end

base_layer = input - detail_layer;
imwrite(uint8(base_layer),base);

end
